<script setup>
import PSinglePlanet from '../components/atoms/PSinglePlanet.vue';
import { usePlanetStore } from '@/stores/planet';
import { useRouter } from 'vue-router';
import PButton from '../components/atoms/PButton.vue';
import { gsap } from 'gsap';
import ScrollToPlugin from 'gsap/ScrollToPlugin';

gsap.registerPlugin(ScrollToPlugin);

const planetStore = usePlanetStore();

const params = new Proxy(new URLSearchParams(window.location.search), {
  get: (searchParams, prop) => searchParams.get(prop)
});

planetStore.selectedPlanetName = params.name;
planetStore.getPlanetData(planetStore.selectedPlanetName);

document.querySelector('body').style.overflow = 'visible';
if (document.contains(document.getElementById('ARButton'))) {
  document.getElementById('ARButton').style.display = 'none';
}

const router = useRouter();

function goToPrevPlanet() {
  gsap.to(window, { duration: 1, scrollTo: '0' });
  router.push(`/planet?name=${planetStore.prevPlanet()}`);
  planetStore.selectedPlanetName = planetStore.prevPlanet();
  planetStore.getPlanetData(planetStore.selectedPlanetName);
}

function goToNextPlanet() {
  gsap.to(window, { duration: 1, scrollTo: '0' });
  router.push(`/planet?name=${planetStore.nextPlanet()}`);
  planetStore.selectedPlanetName = planetStore.nextPlanet();
  planetStore.getPlanetData(planetStore.selectedPlanetName);
}
</script>

<template>
  <main>
    <h1>Planet - {{ planetStore.selectedPlanetName }}</h1>
    <div class="planet">
      <div class="planet__container">
        <Suspense>
          <PSinglePlanet></PSinglePlanet>
        </Suspense>
      </div>
      <div class="planet__content">
        <h2 class="planet__content__title">{{ planetStore.selectedPlanetName }}</h2>
        <div class="planet__content__namesake">
          <p>
            {{ planetStore.planets.namesake }}
          </p>
        </div>
        <div class="planet__content__tagline">
          <span>
            {{ planetStore.planets.tagline }}
          </span>
        </div>
        <div class="planet__content__description">
          <p>
            {{ planetStore.planets.description }}
          </p>
        </div>
        <div class="planet__content__information">
          <p>Distance from sun: {{ planetStore.planets.distanceFromSun }}</p>
          <p>Year length: {{ planetStore.planets.yearLength }} days</p>
          <p v-if="!planetStore.planets.numberOfMoons === 0">
            Number of moons: {{ planetStore.planets.numberOfMoons }}
          </p>
        </div>
        <div class="planet__content__controls">
          <PButton @click.prevent="goToPrevPlanet">Go to {{ planetStore.prevPlanet() }}</PButton>
          <PButton @click.prevent="goToNextPlanet">Go to {{ planetStore.nextPlanet() }}</PButton>
        </div>
      </div>
    </div>
  </main>
</template>

<style scoped lang="scss">
main {
  h1 {
    @include visually-hidden;
  }
  .planet {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    @include responsive-value(margin-top, 50);

    &__container {
      height: 50%;
      width: 100%;
      position: absolute;
      top: 30%;
      left: 50%;
      transform: translate(-50%, -50%);
    }

    &__content {
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;
      @include responsive-value(padding-inline, 4);
      @include responsive-value(gap, 2);

      &__title {
        color: $color-white;
        text-transform: capitalize;
        @include responsive-value(font-size, 4.2);
      }

      &__namesake {
        @include responsive-value(font-size, 3.2);
        position: relative;
        word-wrap: break-word;
        word-break: keep-all;
        text-align: center;
        color: $color-grey;

        p {
          @include responsive-value(line-height, 3);
        }

        &::after,
        &::before {
          content: '-';
          position: absolute;
          top: 0;
        }

        &::after {
          @include responsive-value(right, -2.5);
        }

        &::before {
          @include responsive-value(left, -2.5);
        }
      }

      &__tagline {
        @include responsive-value(left, 5);
        @include responsive-value(top, 1);
        border: rs(0.1) $color-dark-blue solid;
        @include responsive-value(padding, 1);
        @include responsive-value(border-radius, 50);
        @include responsive-value(font-size, 1.6);
        @include responsive-value(margin-bottom, 5);
      }

      &__description {
        @include responsive-value(font-size, 2.2);
        @include responsive-value(margin-bottom, 2.5);
        @include small-up {
          max-width: 70%;
        }
        p {
          @include responsive-value(line-height, 3);
        }
      }

      &__information {
        @include responsive-value(font-size, 2.2);
        @include responsive-value(margin-bottom, 2.5);
        p {
          @include responsive-value(line-height, 3);
        }
      }

      &__controls {
        display: flex;
        width: fit-content;
        @include responsive-value(gap, 2);
        justify-content: center;
      }
    }
  }
}
</style>
